
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535L
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x18:
	.DB  0x81,0xF3,0x49,0x61,0x33,0x25,0x5,0xF1
	.DB  0x81,0x21,0xD,0x5F,0xFF

__GLOBAL_INI_TBL:
	.DW  0x0D
	.DW  _sym
	.DW  _0x18*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 03.10.2010
;Author  : NeVaDa
;Company : Microsoft
;Comments:
;
;
;Chip type               : ATmega8535L
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;/*
;// 1 Wire Bus functions
;#asm
;   .equ __w1_port=0x18 ;PORTB
;   .equ __w1_bit=4
;#endasm
;#include <1wire.h>
;#include <ds1820.h>
;#define MAX_DS1820 8
;volatile unsigned char ds1820_devices;
;volatile unsigned char ds1820_rom_codes[MAX_DS1820][9];
;*/
;volatile unsigned char start1;//   5   
;volatile unsigned char soft_start;//  
;volatile unsigned char rejim;//       0  ,
;                                    //1   
;                                    //2  
;                                    //3   
;volatile unsigned char zadanie_I; //    
;volatile unsigned char zadanie_U; //    
;//eeprom volatile unsigned char rejim_eep;//       0  ,
;//eeprom volatile unsigned char zadanie_I_eep; //      
;//eeprom volatile unsigned char zadanie_U_eep; //      
;volatile unsigned char U_ADC;      //   U
;volatile unsigned char izmerenoe_U;//        
;volatile unsigned char I_ADC;      //   U
;volatile unsigned char izmerenoe_I;//        
;//bit start;//    0==    1== 
;volatile unsigned char start;
;/********************************* ***************************************************************/
;void start_310 (void){//       
; 0000 0039 void start_310 (void){

	.CSEG
_start_310:
; 0000 003A delay_ms (20);      // 2       
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 003B PORTB.0=1;            //   
	SBI  0x18,0
; 0000 003C if (zadanie_I==0){    //    0
	LDS  R30,_zadanie_I
	CPI  R30,0
	BRNE _0x5
; 0000 003D zadanie_I=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_I,R30
; 0000 003E //zadanie_I_eep=zadanie_I;
; 0000 003F }
; 0000 0040 if (zadanie_U==0){    //    0
_0x5:
	LDS  R30,_zadanie_U
	CPI  R30,0
	BRNE _0x6
; 0000 0041 zadanie_U=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_U,R30
; 0000 0042 //zadanie_U_eep=zadanie_U;
; 0000 0043 }
; 0000 0044 delay_ms (5);       // 0,5 
_0x6:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0045 TCCR2=0x6C;           //  2    
	LDI  R30,LOW(108)
	OUT  0x25,R30
; 0000 0046 }
	RET
;/*******************************************************************************************************************/
;/*************************************   250 *****************************************************/
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 004A {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 004B start1++;
	LDS  R30,_start1
	SUBI R30,-LOW(1)
	STS  _start1,R30
; 0000 004C if (start1==5){// start1  ==5
	LDS  R26,_start1
	CPI  R26,LOW(0x5)
	BRNE _0x7
; 0000 004D soft_start++;  //  soft_start  1
	LDS  R30,_soft_start
	SUBI R30,-LOW(1)
	STS  _soft_start,R30
; 0000 004E start1=0;      // start1
	LDI  R30,LOW(0)
	STS  _start1,R30
; 0000 004F }
; 0000 0050 if (rejim==0 || rejim==1 & soft_start<zadanie_I){//         
_0x7:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x0)
	BREQ _0x9
	RCALL SUBOPT_0x0
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	LDS  R30,_zadanie_I
	LDS  R26,_soft_start
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x8
_0x9:
; 0000 0051 OCR2=soft_start;                                 //  
	LDS  R30,_soft_start
	OUT  0x23,R30
; 0000 0052 }
; 0000 0053 if (rejim==2 || rejim==3 && soft_start<zadanie_U){//         
_0x8:
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x2)
	BREQ _0xC
	RCALL SUBOPT_0x0
	CPI  R26,LOW(0x3)
	BRNE _0xD
	LDS  R30,_zadanie_U
	LDS  R26,_soft_start
	CP   R26,R30
	BRLO _0xC
_0xD:
	RJMP _0xB
_0xC:
; 0000 0054 OCR2=soft_start;                                 //  
	LDS  R30,_soft_start
	OUT  0x23,R30
; 0000 0055 }
; 0000 0056 if (OCR2==zadanie_I || OCR2==zadanie_U){//      
_0xB:
	IN   R30,0x23
	MOV  R26,R30
	LDS  R30,_zadanie_I
	CP   R30,R26
	BREQ _0x11
	IN   R30,0x23
	MOV  R26,R30
	LDS  R30,_zadanie_U
	CP   R30,R26
	BRNE _0x10
_0x11:
; 0000 0057 TIMSK=0x01;//      2      0 "00000001"
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 0058 TCCR0=0x03;//   0         250 
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0059 start=1;//   
	LDI  R30,LOW(1)
	STS  _start,R30
; 0000 005A }
; 0000 005B }
_0x10:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;/*******************************************************************************************************************/
;/****************************  0 250 ***********************************************************/
;volatile unsigned int divider_1000;//  1000 250
;volatile long int divider_125000;//  125000 0,5
;volatile unsigned int divider_2500;//  2500 100
;interrupt [TIM0_OVF] void timer0_ovf_isr(void){
; 0000 0061 interrupt [10] void timer0_ovf_isr(void){
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0062 divider_1000++;
	LDI  R26,LOW(_divider_1000)
	LDI  R27,HIGH(_divider_1000)
	RCALL SUBOPT_0x1
; 0000 0063 if (divider_1000==1000){
	LDS  R26,_divider_1000
	LDS  R27,_divider_1000+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRNE _0x13
; 0000 0064 divider_1000=0;
	LDI  R30,LOW(0)
	STS  _divider_1000,R30
	STS  _divider_1000+1,R30
; 0000 0065 }
; 0000 0066 divider_125000++;
_0x13:
	LDI  R26,LOW(_divider_125000)
	LDI  R27,HIGH(_divider_125000)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0000 0067 if (divider_125000==125000){
	LDS  R26,_divider_125000
	LDS  R27,_divider_125000+1
	LDS  R24,_divider_125000+2
	LDS  R25,_divider_125000+3
	__CPD2N 0x1E848
	BRNE _0x14
; 0000 0068 divider_125000=0;
	LDI  R30,LOW(0)
	STS  _divider_125000,R30
	STS  _divider_125000+1,R30
	STS  _divider_125000+2,R30
	STS  _divider_125000+3,R30
; 0000 0069 }
; 0000 006A divider_2500++;
_0x14:
	LDI  R26,LOW(_divider_2500)
	LDI  R27,HIGH(_divider_2500)
	RCALL SUBOPT_0x1
; 0000 006B if (divider_2500==2500){
	LDS  R26,_divider_2500
	LDS  R27,_divider_2500+1
	CPI  R26,LOW(0x9C4)
	LDI  R30,HIGH(0x9C4)
	CPC  R27,R30
	BRNE _0x15
; 0000 006C divider_2500=0;
	LDI  R30,LOW(0)
	STS  _divider_2500,R30
	STS  _divider_2500+1,R30
; 0000 006D }
; 0000 006E }
_0x15:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;/*******************************************************************************************************************/
;/*************************************   *******************************************
;interrupt [ANA_COMP] void ana_comp_isr(void){//    
;TCCR2=0x00;                                  //  2  
;start=0;                                     // 
;}
;*******************************************************************************************************************/
;/****************************************************************************************************************/
;//  ADC6  
;volatile unsigned char calculator_bufer_I[4]={0,0,0,0};//    
;volatile unsigned char calculator_bufer_U[4]={0,0,0,0};//    
;void ADC_I (void){ //  ADC6
; 0000 007A void ADC_I (void){
_ADC_I:
; 0000 007B ADMUX=0b00100110;
	LDI  R30,LOW(38)
	OUT  0x7,R30
; 0000 007C ADCSRA=0b11000001;// 2
	LDI  R30,LOW(193)
	OUT  0x6,R30
; 0000 007D delay_us(32);
	__DELAY_USB 171
; 0000 007E I_ADC=ADCH;
	IN   R30,0x5
	STS  _I_ADC,R30
; 0000 007F calculator_bufer_I[3]=calculator_bufer_I[2];
	__GETB1MN _calculator_bufer_I,2
	__PUTB1MN _calculator_bufer_I,3
; 0000 0080 calculator_bufer_I[2]=calculator_bufer_I[1];
	__GETB1MN _calculator_bufer_I,1
	__PUTB1MN _calculator_bufer_I,2
; 0000 0081 calculator_bufer_I[1]=calculator_bufer_I[0];
	LDS  R30,_calculator_bufer_I
	__PUTB1MN _calculator_bufer_I,1
; 0000 0082 calculator_bufer_I[0]=I_ADC;
	LDS  R30,_I_ADC
	STS  _calculator_bufer_I,R30
; 0000 0083 izmerenoe_I=(calculator_bufer_I[3]+calculator_bufer_I[2]+calculator_bufer_I[1]+calculator_bufer_I[0])/4;
	__GETB2MN _calculator_bufer_I,3
	CLR  R27
	__GETB1MN _calculator_bufer_I,2
	RCALL SUBOPT_0x2
	__GETB1MN _calculator_bufer_I,1
	RCALL SUBOPT_0x2
	LDS  R30,_calculator_bufer_I
	RCALL SUBOPT_0x2
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	STS  _izmerenoe_I,R30
; 0000 0084 }
	RET
;//  ADC7  
;void ADC_U (void){ //  ADC7
; 0000 0086 void ADC_U (void){
; 0000 0087 ADMUX=0b00100111;
; 0000 0088 ADCSRA=0b11000001;// 2
; 0000 0089 delay_us(32);
; 0000 008A U_ADC=ADCH;
; 0000 008B calculator_bufer_U[3]=calculator_bufer_U[2];
; 0000 008C calculator_bufer_U[2]=calculator_bufer_U[1];
; 0000 008D calculator_bufer_U[1]=calculator_bufer_U[0];
; 0000 008E calculator_bufer_U[0]=U_ADC;
; 0000 008F izmerenoe_U=(calculator_bufer_U[3]+calculator_bufer_U[2]+calculator_bufer_U[1]+calculator_bufer_U[0])/4;
; 0000 0090 }
;/*******************************************************************************************************************/
;/******************************************** ***********************************************************/
;// 
;void PWM_control_I (void){
; 0000 0094 void PWM_control_I (void){
; 0000 0095 volatile unsigned char control_I;//      
; 0000 0096 control_I=izmerenoe_I;
;	control_I -> Y+0
; 0000 0097 if (izmerenoe_I < zadanie_I){
; 0000 0098 control_I++;
; 0000 0099 OCR2=control_I;
; 0000 009A }
; 0000 009B if (izmerenoe_I > zadanie_I){
; 0000 009C control_I--;
; 0000 009D OCR2=control_I;
; 0000 009E }
; 0000 009F }
;/*// 
;void PWM_control_U (void){
;volatile unsigned char control_U;//      
;control_U=izmerenoe_U;
;if (izmerenoe_U < zadanie_U){
;control_U++;
;OCR2=control_U;
;}
;if (izmerenoe_U > zadanie_U){
;control_U--;
;OCR2=control_U;
;}
;}
;*/
;/*******************************************************************************************************************/
;/******************************************* **************************************************/
;/*********************   *******
;              a
;            -----
;          f|     |b
;           |  g  |
;            -----
;          e|     |c
;           |  d  |
;            ----- *h
;g      f      e      d      c      b      a      in
;p7    p6    p5    p4    p3    p2    p1    p0
;**********************************************************************/
;#define dig1I PORTA.0//PORTD.5         dig1
;#define dig2I PORTA.1//PORTD.6         dig2
;#define dig3I PORTA.2//PORTD.7        dig3
;#define dig1U PORTA.3//PORTD.5         dig1
;#define dig2U PORTA.4//PORTD.6         dig2
;#define dig3U PORTA.5//PORTD.7        dig3
;unsigned char sym[]={
;0b10000001, //(0)0
;0b11110011, //(1)1
;0b01001001, //(2)2
;0b01100001, //(3)3
;0b00110011, //(4)4
;0b00100101, //(5)5
;0b00000101, //(6)6
;0b11110001, //(7)7
;0b10000001, //(8)8
;0b00100001, //(9)9
;0b00001101, //(10)E
;0b01011111, //(11)r
;0b11111111  //(12)  
;};

	.DSEG
;
;volatile unsigned char indy_I;//         
;volatile unsigned char indy_U;//         
;volatile unsigned char cur_dig;//  
;volatile unsigned char sym_out[6];// sym_out   ( 6)        
;/*****************************************************************/
;void recoding (void){
; 0000 00D7 void recoding (void){

	.CSEG
; 0000 00D8 /****************** *****************************/
; 0000 00D9 if (divider_2500==1){
; 0000 00DA volatile unsigned char indy_static_I;//         
; 0000 00DB volatile unsigned char indy_static_U;//         
; 0000 00DC indy_static_I=indy_I;
;	indy_static_I -> Y+1
;	indy_static_U -> Y+0
; 0000 00DD indy_static_U=indy_U;
; 0000 00DE if (indy_static_I<255){//  indication  255
; 0000 00DF indy_I=izmerenoe_I;             //indy_I  izmerenoe_I  divider_1000  1
; 0000 00E0 sym_out[0]=indy_I%10;           //  sym_out 0       
; 0000 00E1 indy_I=indy_I/10;             //  indication      380  38
; 0000 00E2 sym_out[1]=indy_I%10;           //  8   
; 0000 00E3 indy_I=indy_I/10;             // 38  3
; 0000 00E4 sym_out[2]=indy_I;              //    3
; 0000 00E5 }
; 0000 00E6 else                              // 
; 0000 00E7 {
; 0000 00E8 sym_out[0]=11;                   //
; 0000 00E9 sym_out[1]=10;                   //Er
; 0000 00EA sym_out[2]=12;                   // 0   
; 0000 00EB }
; 0000 00EC /****************** **********************/
; 0000 00ED if (indy_static_U<255){  //  indication  255
; 0000 00EE indy_U=izmerenoe_U;      //indy_U  izmerenoe_U
; 0000 00EF sym_out[3]=indy_U%10;    //  sym_out 0       
; 0000 00F0 indy_U=indy_U/10;        //  indication      380  38
; 0000 00F1 sym_out[4]=indy_U%10;    //  8   
; 0000 00F2 indy_U=indy_U/10;        // 38  3
; 0000 00F3 sym_out[5]=indy_U;       //    3
; 0000 00F4 }
; 0000 00F5 else                     // 
; 0000 00F6 {
; 0000 00F7 sym_out[3]=11;           //
; 0000 00F8 sym_out[4]=10;           //Er
; 0000 00F9 sym_out[5]=12;           // 0   
; 0000 00FA }
; 0000 00FB 
; 0000 00FC /**********     ********************/
; 0000 00FD PORTB=sym[12];                                                         //  B
; 0000 00FE switch (cur_dig){                                                      //   
; 0000 00FF case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
; 0000 0100 case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
; 0000 0101 case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
; 0000 0102 case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
; 0000 0103 case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
; 0000 0104 case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
; 0000 0105 }
; 0000 0106 
; 0000 0107 if (indy_static_I<10){                 //  adc_dataI<10
; 0000 0108 dig2I=0; dig1I=0;                          // 2  
; 0000 0109 }
; 0000 010A if (indy_static_I<100){                //  adc_dataI<100
; 0000 010B dig2I=0;                                   // 1  
; 0000 010C }
; 0000 010D if (indy_static_U<10){                //  adc_dataI<10
; 0000 010E dig2U=0; dig1U=0;                         // 2  
; 0000 010F }
; 0000 0110 if (indy_static_U<100){               //  adc_dataI<100
; 0000 0111 dig2U=0;                                  // 1  
; 0000 0112 }
; 0000 0113 if (divider_1000==1 || divider_1000==501){
; 0000 0114 PORTB=sym[sym_out[cur_dig]];              //      
; 0000 0115 cur_dig=cur_dig+1;                        //  cur_dig  1
; 0000 0116 if (cur_dig==5){
; 0000 0117  cur_dig=0;                               //  cur_dig     3
; 0000 0118 }
; 0000 0119 }
; 0000 011A }
; 0000 011B }
;/*******************************************************************************************************************/
;/*************************************************************************************************************/
;void button (void){
; 0000 011E void button (void){
; 0000 011F #define b_bolshe PORTD.0                                       // 
; 0000 0120 #define b_menshe PORTD.1                                       // 
; 0000 0121 #define b_rejim PORTD.2                                        //  
; 0000 0122 #define b_parametr PORTD.3                                     //  
; 0000 0123 float koficient;                                               //      
; 0000 0124 if (divider_2500==1){                                          //  100    
;	koficient -> Y+0
; 0000 0125 if (b_bolshe==0 || b_menshe==0 || b_rejim==0 || b_parametr==0){//    
; 0000 0126 TCCR2=0x00;                                                    //  2  
; 0000 0127 }
; 0000 0128 if (b_rejim==0 && b_bolshe==0 && b_menshe==1 && b_parametr==1){   //    
; 0000 0129 rejim++;                                                       //   
; 0000 012A if (rejim==3){                                                 // 
; 0000 012B rejim=0;                                                       //   3 
; 0000 012C }
; 0000 012D }
; 0000 012E if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==0 || rejim==1){//         
; 0000 012F zadanie_I++;
; 0000 0130 koficient=zadanie_I/1.275;
; 0000 0131 indy_I=(unsigned char)koficient;
; 0000 0132 }
; 0000 0133 if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==0 || rejim==1){//         
; 0000 0134 zadanie_I--;
; 0000 0135 koficient=zadanie_I/1.275;
; 0000 0136 indy_I=(unsigned char)koficient;
; 0000 0137 }
; 0000 0138 if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==2 || rejim==3){//         
; 0000 0139 zadanie_U++;
; 0000 013A koficient=zadanie_U/1.275;
; 0000 013B indy_U=(unsigned char)koficient;
; 0000 013C }
; 0000 013D if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==2 || rejim==3){//         
; 0000 013E zadanie_U--;
; 0000 013F koficient=zadanie_U/1.275;
; 0000 0140 indy_U=(unsigned char)koficient;
; 0000 0141 }
; 0000 0142 }
; 0000 0143 }
;/*******************************************************************************************************************/
;/**********************************************************************************************************/
;#define l_pad PORTD.4
;#define l_pad_pulse PORTD.5
;#define l_jest PORTD.6
;#define l_jest_pulse PORTD.6
;#define l_alarm PORTB.7
;void led_rejim (void){
; 0000 014B void led_rejim (void){
; 0000 014C switch (rejim){
; 0000 014D case 0:{l_pad=0; l_pad_pulse=1; l_jest=1; l_jest_pulse=1;};
; 0000 014E case 1:{l_pad_pulse=0; l_pad=1; l_jest=1; l_jest_pulse=1;};
; 0000 014F case 2:{l_jest=0; l_pad_pulse=1; l_pad=1; l_jest_pulse=1;};
; 0000 0150 case 3:{l_jest_pulse=0; l_jest=1; l_pad_pulse=1; l_pad=1;};
; 0000 0151 }
; 0000 0152 }
;/*******************************************************************************************************************/
;
;void main(void)
; 0000 0156 {
_main:
; 0000 0157 // Declare your local variables here
; 0000 0158 
; 0000 0159 // Input/Output Ports initialization
; 0000 015A // Port A initialization
; 0000 015B // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 015C // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 015D PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 015E DDRA=0x3F;
	LDI  R30,LOW(63)
	OUT  0x1A,R30
; 0000 015F 
; 0000 0160 // Port B initialization
; 0000 0161 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0162 // State7=1 State6=1 State5=1 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0163 PORTB=0xE0;
	LDI  R30,LOW(224)
	OUT  0x18,R30
; 0000 0164 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0165 
; 0000 0166 // Port C initialization
; 0000 0167 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0168 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 0169 PORTC=0xFF;
	OUT  0x15,R30
; 0000 016A DDRC=0xFF;
	OUT  0x14,R30
; 0000 016B 
; 0000 016C // Port D initialization
; 0000 016D // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 016E // State7=0 State6=1 State5=1 State4=1 State3=P State2=P State1=P State0=P
; 0000 016F PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
; 0000 0170 DDRD=0xF0;
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 0171 
; 0000 0172 // Timer/Counter 0 initialization
; 0000 0173 // Clock source: System Clock
; 0000 0174 // Clock value: Timer 0 Stopped
; 0000 0175 // Mode: Normal top=FFh
; 0000 0176 // OC0 output: Disconnected
; 0000 0177 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0178 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0179 OCR0=0x00;
	OUT  0x3C,R30
; 0000 017A 
; 0000 017B // Timer/Counter 1 initialization
; 0000 017C // Clock source: System Clock
; 0000 017D // Clock value: Timer1 Stopped
; 0000 017E // Mode: Normal top=FFFFh
; 0000 017F // OC1A output: Discon.
; 0000 0180 // OC1B output: Discon.
; 0000 0181 // Noise Canceler: Off
; 0000 0182 // Input Capture on Falling Edge
; 0000 0183 // Timer1 Overflow Interrupt: Off
; 0000 0184 // Input Capture Interrupt: Off
; 0000 0185 // Compare A Match Interrupt: Off
; 0000 0186 // Compare B Match Interrupt: Off
; 0000 0187 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0188 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0189 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 018A TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 018B ICR1H=0x00;
	OUT  0x27,R30
; 0000 018C ICR1L=0x00;
	OUT  0x26,R30
; 0000 018D OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 018E OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 018F OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0190 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0191 
; 0000 0192 // Timer/Counter 2 initialization
; 0000 0193 // Clock source: System Clock
; 0000 0194 // Clock value: Timer2 Stopped
; 0000 0195 // Mode: Normal top=FFh
; 0000 0196 // OC2 output: Disconnected
; 0000 0197 ASSR=0x00;
	OUT  0x22,R30
; 0000 0198 TCCR2=0x00;
	OUT  0x25,R30
; 0000 0199 TCNT2=0x00;
	OUT  0x24,R30
; 0000 019A OCR2=0x00;
	OUT  0x23,R30
; 0000 019B 
; 0000 019C // External Interrupt(s) initialization
; 0000 019D // INT0: Off
; 0000 019E // INT1: Off
; 0000 019F // INT2: Off
; 0000 01A0 MCUCR=0x00;
	OUT  0x35,R30
; 0000 01A1 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 01A2 
; 0000 01A3 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01A4 TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 01A5 
; 0000 01A6 // Analog Comparator initialization
; 0000 01A7 // Analog Comparator: On
; 0000 01A8 // The Analog Comparator's positive input is
; 0000 01A9 // connected to the Bandgap Voltage Reference
; 0000 01AA // Interrupt on Falling Output Edge
; 0000 01AB // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01AC //ACSR=0x4A;
; 0000 01AD ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 01AE SFIOR=0x00;
	OUT  0x30,R30
; 0000 01AF 
; 0000 01B0 /*** ADC initialization
; 0000 01B1 // ADC Clock frequency: 1000,000 kHz
; 0000 01B2 // ADC Voltage Reference: AREF pin
; 0000 01B3 // ADC High Speed Mode: Off
; 0000 01B4 // ADC Auto Trigger Source: Free Running
; 0000 01B5 // Only the 8 most significant bits of
; 0000 01B6 // the AD conversion result are used
; 0000 01B7 ADMUX=ADC_VREF_TYPE & 0xff;
; 0000 01B8 ADCSRA=0xA4;
; 0000 01B9 SFIOR&=0x0F;
; 0000 01BA ***/
; 0000 01BB // Determine the number of DS1820 devices
; 0000 01BC // connected to the 1 Wire bus
; 0000 01BD //ds1820_devices=w1_search(0xf0,ds1820_rom_codes);
; 0000 01BE 
; 0000 01BF // Global enable interrupts
; 0000 01C0 #asm("sei")
	sei
; 0000 01C1 /*******************************************************************************************************************/
; 0000 01C2 start_310();
	RCALL _start_310
; 0000 01C3 while (1){
_0xC9:
; 0000 01C4 while (start==1 & rejim==0){//        
_0xCC:
	LDS  R26,_start
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0xCE
; 0000 01C5 ADC_I();                     //  
	RCALL _ADC_I
; 0000 01C6 //PWM_control_I();             //    
; 0000 01C7 //ADC_U();                     // 
; 0000 01C8 //recoding ();                 //  
; 0000 01C9 //button();                    // 
; 0000 01CA //led_rejim();                 //     
; 0000 01CB }
	RJMP _0xCC
_0xCE:
; 0000 01CC }
	RJMP _0xC9
; 0000 01CD 
; 0000 01CE 
; 0000 01CF 
; 0000 01D0 
; 0000 01D1 
; 0000 01D2 
; 0000 01D3 
; 0000 01D4 
; 0000 01D5 }
_0xCF:
	RJMP _0xCF

	.DSEG
_start1:
	.BYTE 0x1
_soft_start:
	.BYTE 0x1
_rejim:
	.BYTE 0x1
_zadanie_I:
	.BYTE 0x1
_zadanie_U:
	.BYTE 0x1
_U_ADC:
	.BYTE 0x1
_izmerenoe_U:
	.BYTE 0x1
_I_ADC:
	.BYTE 0x1
_izmerenoe_I:
	.BYTE 0x1
_start:
	.BYTE 0x1
_divider_1000:
	.BYTE 0x2
_divider_125000:
	.BYTE 0x4
_divider_2500:
	.BYTE 0x2
_calculator_bufer_I:
	.BYTE 0x4
_calculator_bufer_U:
	.BYTE 0x4
_sym:
	.BYTE 0xD
_indy_I:
	.BYTE 0x1
_indy_U:
	.BYTE 0x1
_cur_dig:
	.BYTE 0x1
_sym_out:
	.BYTE 0x6

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	LDS  R26,_rejim
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

;END OF CODE MARKER
__END_OF_CODE:
